`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 16.02.2021 12:11:17
// Design Name: 
// Module Name: tb_axi4_lite_mm
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module tb_axi4_Lite_MM;

        // Parameters of Axi Slave Bus Interface S_AXI
        parameter integer C_S_AXI_DATA_WIDTH    = 32;
        parameter integer C_S_AXI_ADDR_WIDTH    = 18;

        reg  s_axi_aclk;
        reg  s_axi_aresetn;
        reg [C_S_AXI_ADDR_WIDTH-1 : 0] s_axi_awaddr;
        // reg [2 : 0] s_axi_awprot;
        reg  s_axi_awvalid;
        wire  s_axi_awready;
        reg [C_S_AXI_DATA_WIDTH-1 : 0] s_axi_wdata;
        //reg [(C_S_AXI_DATA_WIDTH/8)-1 : 0] s_axi_wstrb;
        reg  s_axi_wvalid;
        wire  s_axi_wready;
        // wire [1 : 0] s_axi_bresp;
         wire  s_axi_bvalid;
        reg  s_axi_bready;
        reg [C_S_AXI_ADDR_WIDTH-1 : 0] s_axi_araddr;
        //reg [2 : 0] s_axi_arprot;
        reg  s_axi_arvalid;
        wire  s_axi_arready;
        wire [C_S_AXI_DATA_WIDTH-1 : 0] s_axi_rdata;
        //wire [1 : 0] s_axi_rresp;
        wire  s_axi_rvalid;
        reg  s_axi_rready;
    
    axi4_lite_v1_0_S_AXI_1 # ( 
            .C_S_AXI_DATA_WIDTH(C_S_AXI_DATA_WIDTH),
            .C_S_AXI_ADDR_WIDTH(C_S_AXI_ADDR_WIDTH)
        ) axi4_lite_v1_0_S_AXI_inst (
            .S_AXI_ACLK(s_axi_aclk),
            .S_AXI_ARESETN(s_axi_aresetn),
            .S_AXI_AWADDR(s_axi_awaddr),
            //.S_AXI_AWPROT(s_axi_awprot),
            .S_AXI_AWVALID(s_axi_awvalid),
            .S_AXI_AWREADY(s_axi_awready),
            .S_AXI_WDATA(s_axi_wdata),
            //.S_AXI_WSTRB(s_axi_wstrb),
            .S_AXI_WVALID(s_axi_wvalid),
            .S_AXI_WREADY(s_axi_wready),
            //.S_AXI_BRESP(s_axi_bresp),
            .S_AXI_BVALID(s_axi_bvalid),
            .S_AXI_BREADY(s_axi_bready),
            .S_AXI_ARADDR(s_axi_araddr),
            //.S_AXI_ARPROT(s_axi_arprot),
            .S_AXI_ARVALID(s_axi_arvalid),
            .S_AXI_ARREADY(s_axi_arready),
            .S_AXI_RDATA(s_axi_rdata),
            //.S_AXI_RRESP(s_axi_rresp),
            .S_AXI_RVALID(s_axi_rvalid),
            .S_AXI_RREADY(s_axi_rready)
        );
        

      initial
        begin  
           s_axi_aclk = 0;
           s_axi_aresetn = 0;
           s_axi_awaddr = 0;
           s_axi_awvalid = 0;           // intial condition.
           s_axi_wdata  = 0;
           s_axi_wvalid = 0;
           s_axi_bready = 0;
           s_axi_araddr = 0;
           s_axi_arvalid = 0;
           s_axi_rready = 0;

           #8;
           s_axi_aresetn = 1;               // wrtie 
           s_axi_awvalid = 1;
           s_axi_awaddr = 18'h0C;
           s_axi_wdata  = 32'h11_44_33_22;
           s_axi_wvalid = 1;
           s_axi_bready = 1;
           #8
           s_axi_awvalid = 0;               // added on 23022021.
           s_axi_wvalid = 0;    
           #8;
           //s_axi_awaddr = 18'h04;
           //s_axi_wdata  = 32'haa_bb_cc_ff;
           #8;
           s_axi_araddr = 18'h0C;       // read
           s_axi_arvalid = 1;
           s_axi_rready = 1;
           
           #8;
           s_axi_arvalid = 0;
//           s_axi_araddr = 18'h04;
//           s_axi_arvalid = 0;
           s_axi_aresetn = 1;           // write
           s_axi_awvalid = 1;
           s_axi_wvalid = 1;
           s_axi_awaddr = 18'h10;
           s_axi_wdata  = 32'h88_77_66_55;  //66_55_77_88;
           
           //s_axi_bready = 1;
//            #12
//           s_axi_awvalid = 0;               // added on 23022021.
//           s_axi_wvalid = 0;  
          
          #12
          s_axi_araddr = 18'h10;  
          #4 s_axi_arvalid = 1;         
           s_axi_rready = 1;   
          
          #8;
           s_axi_arvalid = 0;           // write
           s_axi_awvalid = 1;
           s_axi_awaddr = 18'h1C;
           s_axi_wdata  = 32'h22_44_88_aa;  //66_55_77_88;
           s_axi_wvalid = 1;
           //s_axi_bready = 1;
                
           #12;
           s_axi_araddr = 18'h1C;           // read
           #4 s_axi_arvalid = 1;         
           s_axi_rready = 1;   
           
           #8;
             s_axi_arvalid = 0;
            
/*           repeat(8)
             begin
                 $display("==========================  tb values  =========================================");
               # 4 s_axi_wdata  = $random;
                 s_axi_awaddr   = $urandom%40;  
                 $display("WDATA = %h\t AWADDR = %h",s_axi_wdata,s_axi_awaddr);                        
             end*/
           # 400 $finish; 

           
        end

        always #2 s_axi_aclk = ~s_axi_aclk;
    endmodule
